<template>
  <div id="app">

    <nav>
      <div class="nav-wrapper blue darken-1">
        <a href="#" class="brand-logo center">Contas</a>
      </div>
    </nav>

    <div class="container">

      <ul>
          <li v-for="(erro, index) of errors" :key="index"> 
              campo <b> {{ erro.field }} - {{ erro.defaultMessage }} </b>
          </li>
      </ul>

      <form @submit.prevent="salvar">

          <label>Descrição</label>
          <input type="text" placeholder="Descrição" v-model="conta.descricao">

          <label>N° de Parcelas</label>
          <input type="text" placeholder="Número de parcelas" v-model="conta.numParcelas">

          <label>Usuário</label>
          <input type="text" placeholder="Nome do usuário" v-model="conta.nome">

          <label>Sobrenome</label>
          <input type="text" placeholder="Sobrenome" v-model="conta.sobrenome">

          <label>E-mail</label>
          <input type="text" placeholder="Email do usuário" v-model="conta.email">

          <button class="waves-effect waves-light btn-small">Salvar<i class="material-icons left">save</i></button>

      </form>

      <table>

        <thead>

          <tr>
            <th>DESCRIÇÃO</th>
            <th>N° DE PARCELAS</th>
            <th>NOME DO USUÁRIO</th>
            <th>SOBRENOME</th>
            <th>E-MAIL</th>
            <th>OPCÕES</th>
          </tr>

        </thead>

        <tbody>

          <tr v-for="conta of contas" :key="conta.id">

            <td> {{ conta.descricao }} </td>
            <td> {{ conta.numParcelas }} </td>
            <td> {{ conta.usuario.nome }} </td>
            <td> {{ conta.usuario.sobrenome }} </td>
            <td> {{ conta.usuario.email }} </td>
            <td>
              <button @click="editar(conta)" class="waves-effect btn-small blue darken-1"><i class="material-icons">create</i></button>
              <button @click="remover(conta)" class="waves-effect btn-small red darken-1"><i class="material-icons">delete_sweep</i></button>
            </td>

          </tr>

        </tbody>
      
      </table>

    </div>

  </div>
</template>

<script>

import Conta from '../service/contas';

export default {

  data(){
    return {
      conta: {
        id: '',
        descricao: '',
        numParcelas: '',
        nome: '',
        sobrenome: '',
        email: ''
      },

      contas: [],
      errors: []
    }
  },

  mounted(){
      this.listar()
    },

  methods: {
    listar() {
    Conta.listar().then(resposta => {
      this.contas = resposta.data
    })
  },

  salvar () {
      if(!this.conta.id){
        Conta.salvar(this.conta).then(resposta => {
          this.conta = {}
          alert('Conta cadastrada com sucesso!')
          this.listar()
          this.errors = []
        }).catch(e => {
          this.errors = e.response.data.errors
      })
    }else{
      Conta.atualizar(this.conta).then(resposta => {
          this.conta = {}
          alert('Conta atualizada com sucesso!')
          this.listar()
          this.errors = []
        }).catch(e => {
          this.errors = e.response.data.errors
      })
    }

  },

  editar(conta){
    this.conta = conta
  },

  remover(conta){
    if(confirm('Deseja excluir essa conta?')){
      Conta.apagar(conta).then(resposta => {
        this.listar();
        this.errors = []
      }).catch(e => {
        this.errors = e.response.data.errors
      })
    }
  }
}
}

</script>